diff -ruN vdr-1.5.9/pat.c vdr-1.5.10/pat.c
--- vdr-1.5.9/pat.c	2007-01-05 11:41:55.000000000 +0100
+++ vdr-1.5.10/pat.c	2007-09-02 12:44:19.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 1.17 2007/01/05 10:41:55 kls Exp $
+ * $Id: pat.c 1.18 2007/09/02 10:44:19 kls Exp $
  */
 
 #include "pat.h"
@@ -331,11 +331,14 @@
         int Ppid = pmt.getPCRPid();
         int Apids[MAXAPIDS + 1] = { 0 }; // these lists are zero-terminated
         int Dpids[MAXDPIDS + 1] = { 0 };
+        int Spids[MAXSPIDS + 1] = { 0 };
         char ALangs[MAXAPIDS][MAXLANGCODE2] = { "" };
         char DLangs[MAXDPIDS][MAXLANGCODE2] = { "" };
+        char SLangs[MAXSPIDS][MAXLANGCODE2] = { "" };
         int Tpid = 0;
         int NumApids = 0;
         int NumDpids = 0;
+        int NumSpids = 0;
         for (SI::Loop::Iterator it; pmt.streamLoop.getNext(stream, it); ) {
             switch (stream.getStreamType()) {
               case 1: // STREAMTYPE_11172_VIDEO
@@ -387,6 +390,26 @@
                             case SI::AC3DescriptorTag:
                                  dpid = stream.getPid();
                                  break;
+                            case SI::SubtitlingDescriptorTag:
+                                 if (NumSpids < MAXSPIDS) {
+                                    Spids[NumSpids] = stream.getPid();
+                                    SI::SubtitlingDescriptor *sd = (SI::SubtitlingDescriptor *)d;
+                                    SI::SubtitlingDescriptor::Subtitling sub;
+                                    char *s = SLangs[NumSpids];
+                                    int n = 0;
+                                    for (SI::Loop::Iterator it; sd->subtitlingLoop.getNext(sub, it); ) {
+                                        if (sub.languageCode[0]) {
+                                           if (n > 0)
+                                              *s++ = '+';
+                                           strn0cpy(s, I18nNormalizeLanguageCode(sub.languageCode), MAXLANGCODE1);
+                                           s += strlen(s);
+                                           if (n++ > 1)
+                                              break;
+                                           }
+                                        }
+                                    NumSpids++;
+                                    }
+                                 break;
                             case SI::TeletextDescriptorTag:
                                  Tpid = stream.getPid();
                                  break;
@@ -416,7 +439,7 @@
                 }
             }
         if (Setup.UpdateChannels >= 2) {
-           Channel->SetPids(Vpid, Vpid ? Ppid : 0, Apids, ALangs, Dpids, DLangs, Tpid);
+           Channel->SetPids(Vpid, Vpid ? Ppid : 0, Apids, ALangs, Dpids, DLangs, Spids, SLangs, Tpid);
            Channel->SetCaIds(CaDescriptors->CaIds());
            }
         Channel->SetCaDescriptors(CaDescriptorHandler.AddCaDescriptors(CaDescriptors));
diff -ruN vdr-1.5.9/player.h vdr-1.5.10/player.h
--- vdr-1.5.9/player.h	2006-01-06 12:29:27.000000000 +0100
+++ vdr-1.5.10/player.h	2007-10-13 14:18:10.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.h 1.19 2006/01/06 11:29:27 kls Exp $
+ * $Id: player.h 1.20 2007/10/13 12:18:10 kls Exp $
  */
 
 #ifndef __PLAYER_H
@@ -24,6 +24,7 @@
   bool DeviceSetCurrentAudioTrack(eTrackType Type) { return device ? device->SetCurrentAudioTrack(Type) : false; }
   bool DevicePoll(cPoller &Poller, int TimeoutMs = 0) { return device ? device->Poll(Poller, TimeoutMs) : false; }
   bool DeviceFlush(int TimeoutMs = 0) { return device ? device->Flush(TimeoutMs) : true; }
+  bool DeviceHasIBPTrickSpeed(void) { return device ? device->HasIBPTrickSpeed() : false; }
   void DeviceTrickSpeed(int Speed) { if (device) device->TrickSpeed(Speed); }
   void DeviceClear(void) { if (device) device->Clear(); }
   void DevicePlay(void) { if (device) device->Play(); }
diff -ruN vdr-1.5.9/recording.c vdr-1.5.10/recording.c
--- vdr-1.5.9/recording.c	2007-06-17 15:10:12.000000000 +0200
+++ vdr-1.5.10/recording.c	2007-10-14 12:21:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.154 2007/06/17 13:10:12 kls Exp $
+ * $Id: recording.c 1.156 2007/10/14 10:21:54 kls Exp $
  */
 
 #include "recording.h"
@@ -296,6 +296,17 @@
                strn0cpy(Component->language, s, sizeof(Component->language));
             }
          }
+     // The same applies to subtitles:
+     for (int i = 0; i < MAXSPIDS; i++) {
+         const char *s = Channel->Slang(i);
+         if (*s) {
+            tComponent *Component = Components->GetComponent(i, 3, 3);
+            if (!Component)
+               Components->SetComponent(Components->NumComponents(), 3, 3, s, NULL);
+            else if (strlen(s) > strlen(Component->language))
+               strn0cpy(Component->language, s, sizeof(Component->language));
+            }
+         }
      if (Components != event->Components())
         ((cEvent *)event)->SetComponents(Components);
      }
@@ -818,6 +829,32 @@
   return RemoveVideoFile(FileName());
 }
 
+bool cRecording::Undelete(void)
+{
+  bool result = true;
+  char *NewName = strdup(FileName());
+  char *ext = strrchr(NewName, '.');
+  if (ext && strcmp(ext, DELEXT) == 0) {
+     strncpy(ext, RECEXT, strlen(ext));
+     if (access(NewName, F_OK) == 0) {
+        // the new name already exists, so let's not remove that one:
+        esyslog("ERROR: attempt to undelete '%s', while recording '%s' exists", FileName(), NewName);
+        result = false;
+        }
+     else {
+        isyslog("undeleting recording '%s'", FileName());
+        if (access(FileName(), F_OK) == 0)
+           result = RenameVideoFile(FileName(), NewName);
+        else {
+           isyslog("deleted recording '%s' vanished", FileName());
+           result = false;
+           }
+        }
+     }
+  free(NewName);
+  return result;
+}
+
 void cRecording::ResetResume(void) const
 {
   resume = RESUME_NOT_INITIALIZED;
diff -ruN vdr-1.5.9/recording.h vdr-1.5.10/recording.h
--- vdr-1.5.9/recording.h	2007-06-17 14:53:05.000000000 +0200
+++ vdr-1.5.10/recording.h	2007-10-14 12:11:34.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 1.57 2007/06/17 12:53:05 kls Exp $
+ * $Id: recording.h 1.59 2007/10/14 10:11:34 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -72,6 +72,8 @@
   mutable char *name;
   mutable int fileSizeMB;
   cRecordingInfo *info;
+  cRecording(const cRecording&); // can't copy cRecording
+  cRecording &operator=(const cRecording &); // can't assign cRecording
   static char *StripEpisodeName(char *s);
   char *SortName(void) const;
   int GetResume(void) const;
@@ -100,6 +102,10 @@
   bool Remove(void);
        // Actually removes the file from the disk
        // Returns false in case of error
+  bool Undelete(void);
+       // Changes the file name so that it will be visible in the "Recordings" menu again and
+       // not processed by cRemoveDeletedRecordingsThread.
+       // Returns false in case of error
   };
 
 class cRecordings : public cList<cRecording>, public cThread {
diff -ruN vdr-1.5.9/remux.c vdr-1.5.10/remux.c
--- vdr-1.5.9/remux.c	2007-02-24 17:36:10.000000000 +0100
+++ vdr-1.5.10/remux.c	2007-09-22 14:08:22.000000000 +0200
@@ -11,7 +11,7 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.58 2007/02/24 16:36:10 kls Exp $
+ * $Id: remux.c 1.59 2007/09/22 12:08:22 kls Exp $
  */
 
 #include "remux.h"
@@ -1555,6 +1555,13 @@
             buf[7] = 0x00;
             buf[8] = 0x00;
             count = 9;
+            if (!repacker && subStreamId) {
+               buf[9] = subStreamId;
+               buf[10] = 1;
+               buf[11] = 0;
+               buf[12] = 1;
+               count = 13;
+               }
             break;
     case 1:
             buf[6] = 0x0F;
@@ -1766,6 +1773,19 @@
                   return;
                }
 
+            if (!repacker && subStreamId) {
+               while (c < Count && found < (hlength + 9) && found < plength + 6) {
+                     write_ipack(Buf + c, 1);
+                     c++;
+                     found++;
+                     }
+               if (found == (hlength + 9)) {
+                  uchar sbuf[] = { 0x01, 0x00, 0x00 };
+                  write_ipack(&subStreamId, 1);
+                  write_ipack(sbuf, 3);
+                  }
+               }
+
             while (c < Count && found < plength + 6) {
                   int l = Count - c;
                   if (l + found > plength + 6)
@@ -1856,7 +1876,7 @@
 cRemux::cRemux(int VPid, const int *APids, const int *DPids, const int *SPids, bool ExitOnFailure)
 {
   exitOnFailure = ExitOnFailure;
-  isRadio = VPid == 0 || VPid == 1 || VPid == 0x1FFF;
+  noVideo = VPid == 0 || VPid == 1 || VPid == 0x1FFF;
   numUPTerrors = 0;
   synced = false;
   skipped = 0;
@@ -1888,13 +1908,11 @@
      while (*DPids && numTracks < MAXTRACKS && n < MAXDPIDS)
            ts2pes[numTracks++] = new cTS2PES(*DPids++, resultBuffer, IPACKS, 0x00, 0x80 + n++, new cDolbyRepacker);
      }
-  /* future...
   if (SPids) {
      int n = 0;
      while (*SPids && numTracks < MAXTRACKS && n < MAXSPIDS)
-           ts2pes[numTracks++] = new cTS2PES(*SPids++, resultBuffer, IPACKS, 0x00, 0x28 + n++);
+           ts2pes[numTracks++] = new cTS2PES(*SPids++, resultBuffer, IPACKS, 0x00, 0x20 + n++);
      }
-  */
 }
 
 cRemux::~cRemux()
@@ -2080,7 +2098,7 @@
                l = GetPacketLength(data, resultCount, i);
                if (l < 0)
                   return resultData;
-               if (isRadio) {
+               if (noVideo) {
                   if (!synced) {
                      if (PictureType)
                         *PictureType = I_FRAME;
diff -ruN vdr-1.5.9/remux.h vdr-1.5.10/remux.h
--- vdr-1.5.9/remux.h	2006-03-25 13:27:30.000000000 +0100
+++ vdr-1.5.10/remux.h	2007-09-02 12:19:06.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 1.16 2006/03/25 12:27:30 kls Exp $
+ * $Id: remux.h 1.17 2007/09/02 10:19:06 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -37,7 +37,7 @@
 class cRemux {
 private:
   bool exitOnFailure;
-  bool isRadio;
+  bool noVideo;
   int numUPTerrors;
   bool synced;
   int skipped;
diff -ruN vdr-1.5.9/sections.c vdr-1.5.10/sections.c
--- vdr-1.5.9/sections.c	2005-09-18 13:30:29.000000000 +0200
+++ vdr-1.5.10/sections.c	2007-10-14 14:52:07.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sections.c 1.14 2005/09/18 11:30:29 kls Exp $
+ * $Id: sections.c 1.15 2007/10/14 12:52:07 kls Exp $
  */
 
 #include "sections.h"
@@ -105,7 +105,7 @@
   for (fh = filterHandles.First(); fh; fh = filterHandles.Next(fh)) {
       if (fh->filterData.Is(FilterData->pid, FilterData->tid, FilterData->mask)) {
          if (--fh->used <= 0) {
-            close(fh->handle);
+            device->CloseFilter(fh->handle);
             filterHandles.Del(fh);
             break;
             }
diff -ruN vdr-1.5.9/svdrp.c vdr-1.5.10/svdrp.c
--- vdr-1.5.9/svdrp.c	2007-08-25 11:28:26.000000000 +0200
+++ vdr-1.5.10/svdrp.c	2007-10-13 12:17:48.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.103 2007/08/25 09:28:26 kls Exp $
+ * $Id: svdrp.c 1.104 2007/10/13 10:17:48 kls Exp $
  */
 
 #include "svdrp.h"
@@ -819,7 +819,7 @@
   if (*Option) {
      const char *hp = GetHelpPage(Option, HelpPages);
      if (hp)
-        Reply(214, "%s", hp);
+        Reply(-214, "%s", hp);
      else {
         Reply(504, "HELP topic \"%s\" unknown", Option);
         return;
diff -ruN vdr-1.5.9/tools.c vdr-1.5.10/tools.c
--- vdr-1.5.9/tools.c	2007-08-05 14:18:15.000000000 +0200
+++ vdr-1.5.10/tools.c	2007-10-13 14:00:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.135 2007/08/05 12:18:15 kls Exp $
+ * $Id: tools.c 1.136 2007/10/13 12:00:21 kls Exp $
  */
 
 #include "tools.h"
@@ -791,7 +791,7 @@
                  size_t d = ToPtr - result;
                  size_t r = length / 2;
                  length += r;
-                 result = (char *)realloc(result, length);
+                 Converted = result = (char *)realloc(result, length);
                  ToLength += r;
                  ToPtr = result + d;
                  }
diff -ruN vdr-1.5.9/vdr.c vdr-1.5.10/vdr.c
--- vdr-1.5.9/vdr.c	2007-08-25 10:51:13.000000000 +0200
+++ vdr-1.5.10/vdr.c	2007-08-26 16:36:48.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.299 2007/08/25 08:51:13 kls Exp $
+ * $Id: vdr.c 1.300 2007/08/26 14:36:48 kls Exp $
  */
 
 #include <getopt.h>
@@ -1009,6 +1009,18 @@
                   cDisplayTracks::Process(key);
                key = kNone;
                break;
+          // Subtitle track control:
+          case kSubtitles:
+               if (cControl::Control())
+                  cControl::Control()->Hide();
+               if (!cDisplaySubtitleTracks::IsOpen()) {
+                  DELETE_MENU;
+                  Menu = cDisplaySubtitleTracks::Create();
+                  }
+               else
+                  cDisplaySubtitleTracks::Process(key);
+               key = kNone;
+               break;
           // Pausing live video:
           case kPause:
                if (!cControl::Control()) {
